Update copyright.
[deliverable/binutils-gdb.git] / configure.in
CommitLineData
9bdd52dd 1##############################################################################
eb02fd64 2
041164e4
DZ
3## This file is a shell script fragment that supplies the information
4## necessary to tailor a template configure script into the configure
5## script appropriate for this directory. For more information, check
6## any existing configure script.
ba4513e7 7
041164e4
DZ
8## Be warned, there are two types of configure.in files. There are those
9## used by Autoconf, which are macros which are expanded into a configure
10## script by autoconf. The other sort, of which this is one, is executed
11## by Cygnus configure.
ba4513e7 12
041164e4
DZ
13## For more information on these two systems, check out the documentation
14## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
ba4513e7 15
9bdd52dd 16##############################################################################
041164e4
DZ
17
18### To add a new directory to the tree, first choose whether it is a target
19### or a host dependent tool. Then put it into the appropriate list
20### (library or tools, host or target), doing a dependency sort. For
21### example, gdb requires that byacc (or bison) be built first, so it is in
22### the ${host_tools} list after byacc and bison.
23
24
25# these libraries are used by various programs built for the host environment
26#
6d3055cb 27host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
041164e4 28
f4a7dca7
TL
29if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31fi
32
041164e4
DZ
33# these tools are built for the host environment
34#
35host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
d6c8b354 36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
e718498b 37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
e37bb3c7 38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
bb9ae458 39 recode release sed utils"
041164e4
DZ
40
41
9bdd52dd
DZ
42# these libraries are built for the target environment, and are built after
43# the host libraries and the host tools (which may be a cross compiler)
041164e4 44#
77cd090a 45target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
6218894f 46
041164e4 47
9bdd52dd 48# these tools are built using the target libs, and are intended to run only
9623e828 49# in the target environment
83a47678 50#
9bdd52dd
DZ
51# note: any program that *uses* libraries that are in the "target_libs"
52# list belongs in this list. those programs are also very likely
53# candidates for the "native_only" list which follows
041164e4 54#
b58d9e5d 55target_tools="target-examples target-groff"
041164e4
DZ
56
57################################################################################
58
59## These two lists are of directories that are to be removed from the
60## ${configdirs} list for either cross-compilations or for native-
61## compilations. For example, it doesn't make that much sense to
ab1cbc67 62## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
041164e4
DZ
63## a native environment.
64
65# directories to be built in the native environment only
66#
b58d9e5d 67native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
86c3abaa 68 indent ispell m4 rcs recode sed shellutils tar textutils gash
b58d9e5d 69 uudecode wdiff gprof target-groff"
041164e4 70
9bdd52dd 71# directories to be built in a cross environment only
041164e4 72#
ab1cbc67 73cross_only="target-libiberty target-libgloss target-newlib"
041164e4
DZ
74
75## All tools belong in one of the four categories, and are assigned above
8f30a41e
DE
76## We assign ${configdirs} this way to remove all embedded newlines. This
77## is important because configure will choke if they ever get through.
ca2ce3b3
ILT
78## ${configdirs} is directories we build using the host tools.
79## ${target_configdirs} is directories we build using the target tools.
041164e4 80#
ca2ce3b3
ILT
81configdirs=`echo ${host_libs} ${host_tools}`
82target_configdirs=`echo ${target_libs} ${target_tools}`
041164e4
DZ
83
84################################################################################
ba4513e7 85
378fd382 86srctrigger=move-if-change
eb02fd64 87srcname="gnu development package"
0df06ca0 88
af9fa3c1
ILT
89# This gets set non-empty for some net releases of packages.
90appdirs=""
91
0df06ca0
RP
92# per-host:
93
594c548a
DM
94# Work in distributions that contain no compiler tools, like Autoconf.
95if [ -d ${srcdir}/config ]; then
cec673a2 96case "${host}" in
c71350fc 97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
cec673a2
DZ
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
cec673a2 100 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
48de3495
SS
101 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
102 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
e718498b 103 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
031eff55 104 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
e718498b
DZ
105 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
106 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
49ad26c2 107 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
e718498b 108 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
7e290a5d 109 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
a73fc881 110 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
a48876fc 111 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
a73fc881
ILT
112 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
113 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
115 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
116 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
117 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
a220ba0f 118 i[345]86-*-win32) host_makefile_frag=config/mh-i386win32 ;;
d3c06c91 119 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
54fdaa7b 120 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
39772dd8 121 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
0259fc73 122 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
c71350fc 123 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
9117f609 124 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
af9fa3c1 125 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
89c27486 126 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
fab5d4e3
DZ
127 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
128 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
f4bda0ff 129esac
594c548a 130fi
f4bda0ff 131
ca2ce3b3
ILT
132# See if we can extract a definition of CC from the fragment.
133if [ -z "${CC}" ]; then
4caf3f7d 134 if [ -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
2f9bfdfa
SG
135 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
136 if [ -n "${xx}" ] ; then
137 CC=$xx
138 fi
ca2ce3b3
ILT
139 fi
140fi
141
866cdf6c
ILT
142# The Solaris /usr/ucb/cc compiler does not appear to work.
143case "${host}" in
144 sparc-sun-solaris2*)
145 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
146 could_use=
147 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
148 if [ -d /opt/cygnus/bin ] ; then
80aa1504 149 if [ "$could_use" = "" ] ; then
866cdf6c
ILT
150 could_use="/opt/cygnus/bin"
151 else
152 could_use="$could_use or /opt/cygnus/bin"
153 fi
154 fi
155 if [ "$could_use" = "" ] ; then
156 echo "Warning: compilation may fail because you're using"
157 echo "/usr/ucb/cc. You should change your PATH or CC "
158 echo "variable and rerun configure."
159 else
160 echo "Warning: compilation may fail because you're using"
161 echo "/usr/ucb/cc, when you should use the C compiler from"
162 echo "$could_use. You should change your"
163 echo "PATH or CC variable and rerun configure."
164 fi
165 fi
166 ;;
167esac
168
45329a2c
JM
169# We default to --with-shared on platforms where -fpic is meaningless.
170# Well, we don't yet, but we will.
171if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
172 case "${target}" in
173 alpha-dec-osf*) enable_shared=yes ;;
174 mips-sgi-irix5*) enable_shared=yes ;;
175 *) enable_shared=no ;;
176 esac
177fi
178
179if [ x${enable_shared} = xyes ]; then
180 waugh=
181 case "${host}" in
c9e55665
JM
182 hppa*) waugh=config/mh-papic ;;
183 i[345]86-*) waugh=config/mh-x86pic ;;
184 *) waugh=config/mh-${host_cpu}pic ;;
45329a2c 185 esac
4350753e
JM
186 if [ -f ${srcdir}/${waugh} ]; then
187 if [ -n "${host_makefile_frag}" ] ; then
188 cat ${srcdir}/${host_makefile_frag} > mh-frag
189 cat ${srcdir}/${waugh} >> mh-frag
190 host_makefile_frag=mh-frag
c9e55665
JM
191 else
192 host_makefile_frag=${waugh}
4350753e 193 fi
45329a2c
JM
194 fi
195fi
196
0df06ca0 197# per-target:
bc58b41d 198
9ab10a5b
SEF
199case "${target}" in
200 v810*) target_makefile_frag=config/mt-v810 ;;
138e8532
JM
201 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
202 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
9ab10a5b
SEF
203esac
204
ca2ce3b3 205skipdirs=
719cb03f
DZ
206gasdir=gas
207use_gnu_ld=
208use_gnu_as=
209
9f579565
DZ
210# some tools are so dependent upon X11 that if we're not building with X,
211# it's not even worth trying to configure, much less build, that tool.
212
213case ${with_x} in
e13fa011 214 yes | "") # the default value for this tree is that X11 is available
6a42d184 215 ;;
e13fa011 216 no)
ca2ce3b3 217 skipdirs="${skipdirs} tk gash"
9f579565
DZ
218 ;;
219 *)
220 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
221 ;;
222esac
223
5357f128 224# Some tools are only suitable for building in a "native" situation.
ba4513e7
DZ
225# Those are added when we have a host==target configuration. For cross
226# toolchains, we add some directories that should only be useful in a
227# cross-compiler.
43557c0a 228
2a38983c
DHW
229is_cross_compiler=
230
94028943 231if [ x"${host}" = x"${target}" ] ; then
041164e4
DZ
232 # when doing a native toolchain, don't build the targets
233 # that are in the 'cross only' list
ca2ce3b3 234 skipdirs="${skipdirs} ${cross_only}"
2a38983c 235 is_cross_compiler=no
ab1cbc67 236 target_subdir=.
43557c0a 237else
041164e4
DZ
238 # similarly, don't build the targets in the 'native only'
239 # list when building a cross compiler
ca2ce3b3 240 skipdirs="${skipdirs} ${native_only}"
2a38983c 241 is_cross_compiler=yes
ab1cbc67
PB
242 target_subdir=${target_alias}
243 if [ ! -d ${target_subdir} ] ; then
244 if mkdir ${target_subdir} ; then true
245 else
246 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
247 exit 1
248 fi
249 fi
43557c0a
DZ
250fi
251
055cca84
ILT
252copy_dirs=
253
254# Handle --with-headers=XXX. The contents of the named directory are
52b5deb9 255# copied to $(tooldir)/sys-include.
055cca84
ILT
256if [ x"${with_headers}" != x ]; then
257 if [ x${is_cross_compiler} = xno ]; then
258 echo 1>&2 '***' --with-headers is only supported when cross compiling
259 exit 1
260 fi
261 case "${exec_prefixoption}" in
262 "") x=${prefix} ;;
263 *) x=${exec_prefix} ;;
264 esac
52b5deb9 265 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
055cca84
ILT
266fi
267
268# Handle --with-libs=XXX. Multiple directories are permitted. The
269# contents are copied to $(tooldir)/lib.
270if [ x"${with_libs}" != x ]; then
271 if [ x${is_cross_compiler} = xno ]; then
272 echo 1>&2 '***' --with-libs is only supported when cross compiling
273 exit 1
274 fi
275 # Copy the libraries in reverse order, so that files in the first named
276 # library override files in subsequent libraries.
277 case "${exec_prefixoption}" in
278 "") x=${prefix} ;;
279 *) x=${exec_prefix} ;;
280 esac
281 for l in ${with_libs}; do
282 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
283 done
284fi
285
286# If both --with-headers and --with-libs are specified, default to
287# --without-newlib.
288if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
289 if [ x"${with_newlib}" = x ]; then
290 with_newlib=no
291 fi
292fi
293
99dff294 294# Recognize --with-newlib/--without-newlib.
055cca84 295if [ x${with_newlib} = xno ]; then
ab1cbc67 296 skipdirs="${skipdirs} target-newlib"
99dff294 297elif [ x${with_newlib} = xyes ]; then
ab1cbc67 298 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
055cca84
ILT
299fi
300
4f0ad91b
ILT
301# Default to using --with-stabs for certain targets.
302if [ x${with_stabs} = x ]; then
303 case "${target}" in
304 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
305 with_stabs=yes;
306 withoptions="${withoptions} --with-stabs"
307 ;;
308 esac
309fi
310
055cca84
ILT
311# Handle ${copy_dirs}
312set fnord ${copy_dirs}
313shift
314while [ $# != 0 ]; do
315 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
316 :
317 else
318 echo Copying $1 to $2
319
320 # Use the install script to create the directory and all required
321 # parent directories.
322 if [ -d $2 ]; then
323 :
324 else
325 echo >config.temp
326 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
327 fi
328
329 # Copy the directory, assuming we have tar.
330 # FIXME: Should we use B in the second tar? Not all systems support it.
331 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
332
333 # It is the responsibility of the user to correctly adjust all
334 # symlinks. If somebody can figure out how to handle them correctly
335 # here, feel free to add the code.
336
337 echo $1 > $2/COPIED
338 fi
339 shift; shift
340done
341
eebd76cb
SC
342# Configure extra directories which are host specific
343
344case "${host}" in
efd7b806 345 i[345]86-*-win32* | i[345]86-*-go32*)
a220ba0f 346 configdirs="$configdirs dosrel" ;;
eebd76cb
SC
347esac
348
5357f128 349# Remove more programs from consideration, based on the host or
dfa891fc 350# target this usually means that a port of the program doesn't
8ae559b7 351# exist yet.
dfa891fc 352
52e3ad87
KR
353noconfigdirs=""
354
9f579565 355case "${host}" in
a73fc881 356 i[345]86-*-vsta)
8a3871bb
RS
357 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
358 ;;
a73fc881 359 i[345]86-*-go32)
795f1885 360 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
8c7fd353 361 ;;
a220ba0f 362 i[345]86-*-win32)
600b2f21 363 noconfigdirs="patch diff flex make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
9f579565 364 ;;
a51794f1
JM
365 ppc*-*-pe)
366 noconfigdirs="patch diff flex make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
367 ;;
9f579565 368esac
dfa891fc 369
eebd76cb 370
43557c0a 371case "${target}" in
0f45fbc1 372 *-*-netware)
ab1cbc67 373 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
0f45fbc1 374 ;;
406477a6 375 *-*-vxworks*)
ab1cbc67 376 noconfigdirs="$noconfigdirs target-newlib"
849367a2 377 ;;
6bd3f765
ILT
378 alpha-dec-osf*)
379 # ld works, but does not support shared libraries. emacs doesn't
f4791d95 380 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
2a3486d2
ILT
381 # gas doesn't generate exception information.
382 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
0f45fbc1 383 ;;
04b9315f 384 alpha*-*-*)
6bd3f765 385 # newlib is not 64 bit ready
ab1cbc67 386 noconfigdirs="$noconfigdirs target-newlib"
0f45fbc1 387 ;;
7c71fc39
DE
388# start-sanitize-arc
389 arc-*-*)
7c71fc39
DE
390 ;;
391# end-sanitize-arc
bf150019 392 arm-*-pe*)
bf150019 393 ;;
ff15324f 394 arm-*-riscix*)
318b02b6
KR
395 noconfigdirs="$noconfigdirs ld"
396 ;;
52e3ad87 397 h8300*-*-* | \
8388b9df 398 h8500-*-*)
ab1cbc67 399 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
15ae586e 400 ;;
8a71f0f3 401 hppa*-*-*elf* | \
55ac59da 402 hppa*-*-lites*)
8c92a7d1 403 # Do configure ld/binutils/gas for this case.
99a5da15 404 ;;
15ae586e 405 hppa*-*-*)
408f64bc
JK
406 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
407 # cc is gcc, and on any system a user should be able to link cc to
e37bb3c7 408 # whatever they want. FIXME, emacs emacs19).
8b5405d2 409 case "${CC}" in
e37bb3c7 410 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
772ebace 411 *) ;;
8b5405d2 412 esac
d9f1d487 413 noconfigdirs="$noconfigdirs ld shellutils"
15ae586e 414 ;;
a73fc881 415 i[345]86-*-go32)
632ee4a1 416 # but don't build gdb
ab1cbc67 417 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
8c92a7d1 418 ;;
a220ba0f 419 i[345]86-*-win32)
efd7b806 420 # Can't build gdb for win32 if not native.
600b2f21 421 # make/glob's configure uses some AC_TRY_RUN type tests
77cd090a 422 target_configdirs="$target_configdirs target-winsup"
aef95a96 423 noconfigdirs="$noconfigdirs gdb tcl tk expect make"
e1a1ddc6 424 # always build newlib.
ab1cbc67 425 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
a220ba0f 426 ;;
8c7fd353 427 i[345]86-*-pe)
ab1cbc67 428 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
8c7fd353 429 ;;
a48876fc
SS
430 i[345]86-*-sco3.2v5*)
431 # The linker does not yet know about weak symbols in COFF,
432 # and is not configured to handle mixed ELF and COFF.
433 noconfigdirs="$noconfigdirs gprof ld"
434 ;;
a73fc881 435 i[345]86-*-sco*)
de9117a7
KR
436 noconfigdirs="$noconfigdirs gprof"
437 ;;
a73fc881 438 i[345]86-*-solaris2*)
320c9fff
KR
439 # The linker does static linking correctly, but the Solaris C library
440 # has bugs such that some important functions won't work when statically
441 # linked. (See man pages for getpwuid, for example.)
442 noconfigdirs="$noconfigdirs ld"
443 ;;
a73fc881 444 i[345]86-*-sysv4*)
8b5405d2
DZ
445 # The SYSV4 C compiler doesn't handle Emacs correctly
446 case "${CC}" in
e37bb3c7 447 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
8b5405d2
DZ
448 *) ;;
449 esac
450 # but that's okay since emacs doesn't work anyway
e37bb3c7 451 noconfigdirs="$noconfigdirs emacs emacs19"
8b5405d2 452 ;;
3e1e245d
ILT
453 powerpc-*-aix*)
454 # copied from rs6000-*-* entry
92caaa6a 455 noconfigdirs="$noconfigdirs gprof cvs"
3e1e245d 456 ;;
a51794f1
JM
457 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
458 target_configdirs="$target_configdirs target-winsup"
459 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
460 # always build newlib.
461 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
81d08d0c 462 ;;
2a38983c 463 rs6000-*-lynxos*)
2a38983c
DHW
464 # The CVS server code doesn't work on the RS/6000
465 # Newlib makes problems for libg++ in crosses.
92caaa6a 466 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
2a38983c 467 ;;
8388b9df 468 rs6000-*-*)
92caaa6a 469 noconfigdirs="$noconfigdirs gprof"
fcf4d286 470 ;;
d55a8267
C
471 m68k-*-netbsd*)
472 noconfigdirs="$noconfigdirs gdb"
473 ;;
becf2d8a
JK
474 m68k-apollo-*)
475 noconfigdirs="$noconfigdirs ld binutils gprof"
476 ;;
04b9315f
ILT
477 mips*-*-irix5*)
478 # The GNU linker does not support shared libraries.
82633710
ILT
479 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
480 noconfigdirs="$noconfigdirs ld gprof emacs"
04b9315f 481 ;;
af9fa3c1
ILT
482 mips*-dec-bsd*)
483 noconfigdirs="$noconfigdirs gprof"
484 ;;
485 mips*-*-bsd*)
ffb8885b 486 noconfigdirs="$noconfigdirs gprof"
af9fa3c1 487 ;;
04b9315f 488 mips*-*-*)
52e3ad87 489 noconfigdirs="$noconfigdirs gprof"
fcf4d286 490 ;;
de9117a7 491 romp-*-*)
ca2ce3b3 492 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
de9117a7 493 ;;
817382d1 494 sh-*-*)
719cb03f 495 case "${host}" in
a73fc881 496 i[345]86-*-vsta) ;; # don't add gprof back in
a73fc881 497 i[345]86-*-go32) ;; # don't add gprof back in
ca2ce3b3 498 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
719cb03f
DZ
499 esac
500 ;;
501 sparc-*-sunos4*)
2a38983c 502 if [ x${is_cross_compiler} != xno ] ; then
ab1cbc67 503 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
2a38983c
DHW
504 else
505 use_gnu_ld=no
506 fi
1f69e88d 507 ;;
486e0f0a 508 v810-*-*)
d25fd70d 509 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
486e0f0a 510 ;;
de9117a7 511 vax-*-vms)
ab1cbc67 512 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
de9117a7
KR
513 ;;
514 vax-*-*)
ab1cbc67 515 noconfigdirs="$noconfigdirs target-newlib"
8388b9df 516 ;;
de9117a7 517 *-*-lynxos*)
19b1d034
SS
518 # Newlib makes problems for libg++ in crosses.
519 noconfigdirs="$noconfigdirs target-newlib"
520 ;;
521 *-*-macos* | \
522 *-*-mpw*)
523 # Macs want a resource compiler.
524 configdirs="$configdirs grez"
525 ;;
05cd8d98
HS
526esac
527
bfe725ec
ILT
528# If we are building a Canadian Cross, discard tools that can not be built
529# using a cross compiler. FIXME: These tools should be fixed.
530if [ "${build}" != "${host}" ]; then
531 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
532fi
533
d4cf72b3
BK
534# Make sure we don't let GNU ld be added if we didn't want it.
535if [ x$with_gnu_ld = xno ]; then
536 use_gnu_ld=no
537 noconfigdirs="$noconfigdirs ld"
0b0124c6
BK
538fi
539
d4cf72b3
BK
540# Make sure we don't let GNU as be added if we didn't want it.
541if [ x$with_gnu_as = xno ]; then
542 use_gnu_as=no
543 noconfigdirs="$noconfigdirs gas"
0b0124c6
BK
544fi
545
ca2ce3b3
ILT
546# Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
547# $target_configdirs.
548# If we have the source for $noconfigdirs entries, add them to $notsupp.
efd7b806 549
52e3ad87 550notsupp=""
ca2ce3b3 551for dir in . $skipdirs $noconfigdirs ; do
b58d9e5d 552 dirname=`echo $dir | sed -e s/target-//g`
1c15a33d 553 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
8f30a41e 554 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
555 if [ -r $srcdir/$dirname/configure ] \
556 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
557 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
558 true
559 else
560 notsupp="$notsupp $dir"
561 fi
562 fi
563 fi
564 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
565 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
b58d9e5d
PB
566 if [ -r $srcdir/$dirname/configure ] \
567 || [ -r $srcdir/$dirname/configure.in ]; then
ca2ce3b3
ILT
568 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
569 true
570 else
571 notsupp="$notsupp $dir"
572 fi
52e3ad87
KR
573 fi
574 fi
575done
576
fba66802
ILT
577# Sometimes the tools are distributed with libiberty but with no other
578# libraries. In that case, we don't want to build target-libiberty.
579if [ -n "${target_configdirs}" ]; then
580 others=
b58d9e5d 581 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
fba66802
ILT
582 if [ "$i" != "libiberty" ]; then
583 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
584 others=yes;
585 break;
586 fi
587 fi
588 done
589 if [ -z "${others}" ]; then
590 target_configdirs=
591 fi
592fi
593
ca2ce3b3
ILT
594# Deconfigure all subdirectories, in case we are changing the
595# configuration from one where a subdirectory is supported to one where it
596# is not.
ab1cbc67 597if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
b58d9e5d 598 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
ca2ce3b3
ILT
599 rm -f $i/Makefile
600 done
601fi
ab1cbc67 602if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
b58d9e5d 603 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
ab1cbc67
PB
604 rm -f ${target_subdir}/$i/Makefile
605 done
606fi
ca2ce3b3 607
52e3ad87
KR
608# Produce a warning message for the subdirs we can't configure.
609# This isn't especially interesting in the Cygnus tree, but in the individual
610# FSF releases, it's important to let people know when their machine isn't
611# supported by the one or two programs in a package.
612
9fe444b5 613if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
af9fa3c1
ILT
614 # If $appdirs is non-empty, at least one of those directories must still
615 # be configured, or we error out. (E.g., if the gas release supports a
616 # specified target in some subdirs but not the gas subdir, we shouldn't
617 # pretend that all is well.)
618 if [ -n "$appdirs" ]; then
619 for dir in $appdirs ; do
ca2ce3b3
ILT
620 if [ -r $dir/Makefile.in ]; then
621 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
622 appdirs=""
623 break
624 fi
625 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
626 appdirs=""
627 break
628 fi
af9fa3c1
ILT
629 fi
630 done
631 if [ -n "$appdirs" ]; then
632 echo "*** This configuration is not supported by this package." 1>&2
633 exit 1
634 fi
635 fi
636 # Okay, some application will build, or we don't care to check. Still
637 # notify of subdirs not getting built.
52e3ad87
KR
638 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
639 echo " ${notsupp}" 1>&2
640 echo " (Any other directories should still work fine.)" 1>&2
641fi
642
d4cf72b3
BK
643# Set with_gnu_as and with_gnu_ld as appropriate.
644#
645# This is done by determining whether or not the appropriate directory
646# is available, and by checking whether or not specific configurations
647# have requested that this magic not happen.
648#
649# The command line options always override the explicit settings in
650# configure.in, and the settings in configure.in override this magic.
651#
652# If the default for a toolchain is to use GNU as and ld, and you don't
653# want to do that, then you should use the --without-gnu-as and
654# --without-gnu-ld options for the configure script.
655
656if [ x${use_gnu_as} = x ] ; then
657 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
658 with_gnu_as=yes
659 withoptions="$withoptions --with-gnu-as"
660 fi
661fi
662
663if [ x${use_gnu_ld} = x ] ; then
664 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
665 with_gnu_ld=yes
666 withoptions="$withoptions --with-gnu-ld"
667 fi
668fi
669
45329a2c
JM
670if [ x${enable_shared} = xyes ]; then
671 case "${target}" in
c9e55665
JM
672 hppa*) target_makefile_frag=config/mt-papic ;;
673 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
674 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
45329a2c
JM
675 esac
676fi
677
ca2ce3b3
ILT
678# post-target:
679
b5ae8419
ILT
680# Make sure that the compiler is able to generate an executable. If it
681# can't, we are probably in trouble. We don't care whether we can run the
682# executable--we might be using a cross compiler--we only care whether it
683# can be created. At this point the main configure script has set CC.
684echo "int main () { return 0; }" > conftest.c
685${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
686if [ $? = 0 ] && [ -s conftest ]; then
687 :
688else
689 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
690 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
691 rm -f conftest*
692 exit 1
693fi
694rm -f conftest*
695
ca2ce3b3 696# Record target_configdirs and the configure arguments in Makefile.
ab1cbc67 697target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
ca2ce3b3 698targargs=`echo "${arguments}" | \
7fc36fda
ILT
699 sed -e 's/--norecursion//' \
700 -e 's/--cache[a-z-]*=[^ ]*//' \
701 -e 's/--ho[a-z-]*=[^ ]*//' \
702 -e 's/--ta[a-z-]*=[^ ]*//'`
703
704# Passing a --with-cross-host argument lets the target libraries know
705# whether they are being built with a cross-compiler or being built
706# native. However, it would be better to use other mechanisms to make the
707# sorts of decisions they want to make on this basis. Please consider
708# this option to be deprecated. FIXME.
709if [ x${is_cross_compiler} = xyes ]; then
90bdf864 710 targargs="--with-cross-host=${host_alias} ${targargs}"
7fc36fda
ILT
711fi
712
713targargs="--host=${target_alias} ${targargs}"
ca2ce3b3
ILT
714sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
715 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
ab1cbc67 716 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
ca2ce3b3
ILT
717 Makefile > Makefile.tem
718rm -f Makefile
719mv -f Makefile.tem Makefile
720
bc58b41d
RP
721#
722# Local Variables:
723# fill-column: 131
724# End:
725#
This page took 0.204206 seconds and 4 git commands to generate.